/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	文字エンコード変換クラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.xmo.util;

import jp.co.ntt.lms.xmo.Environment;

/**
 * XMSⅡでの文字エンコード変換をするユーティリティクラスです。
 * @author T.Nijou
 * @version 0.0.0.1
 */
public class ChangeEncode {

	private static final Class THIS_CLASS = new ChangeEncode().getClass();

	/**
	 * 文字変換時の変換先文字セット名です。
	 */
	private static final String AFTER_CHARSET = "Windows-31J";

	/**
	 * 文字変換時の変換前文字セット名です。
	 */
	private static final  String BEFORE_CHARSET = "ISO-8859-1";

	/**
	 * 文字列変換を行います
	 * @param strChange 変換対象文字列
	 * @return String 変換後文字列
	 */
	public static String setChar(String strChange) {
		String strDBtype = "";
		Environment env = null;
		try{
			// 環境ファイルからDB種別情報取得
			env = new Environment();
		}
		catch(Exception e) {
			DebugLog.write( THIS_CLASS, e, DebugLog.HIGHT );
		}
		return setChar(env, strChange);
	}
	
	/**
	 * 文字列変換を行います。
	 * 
	 * @param env XMS.ini 環境設定ファイル読み込みオブジェクト
	 * @param target 変換する文字列
	 * @return
	 */
	public static String setChar(Environment env, String target)
	{
		String strDBtype = "";
		try{
			if (env == null) throw new Exception("Environmentがnullです。");
			//DB種別情報が "0" の時　MS SQLServer
			//DB種別情報が "1" の時　Oracle
			//DB種別情報が "2" の時　PostgreSQL
			//SQLServerの場合
			if ( env.getDBType().equals(Environment.DB_SQLSERVER) ) {
				strDBtype = "0";
			}
			//Oracleの場合
			else if ( env.getDBType().equals(Environment.DB_ORACLE) ) {
				strDBtype = "1";
			}
			//PostgreSQLの場合
			else if ( env.getDBType().equals(Environment.DB_POSTGRE) ) {
				strDBtype = "2";
			}
		}
		catch(Exception e) {
			DebugLog.write( THIS_CLASS, e, DebugLog.HIGHT );
		}
		
		String strRes = "";
		if( target==null || target.equals( "" ) ) {
			return strRes;
		}
		else if ( strDBtype.equals("1") ) {
			return target.trim();
		}
		//PostgreSQL
		else if ( strDBtype.equals("2") ) {
			return target.trim();
		}
		else {
			try {
				strRes = new String(target.getBytes(BEFORE_CHARSET),AFTER_CHARSET);
			}
			catch(Exception e) {
				DebugLog.write( THIS_CLASS, e, DebugLog.HIGHT );
				return strRes;
			}
		}
		return strRes.trim();
	}
	
	/**
	 * 文字列変換を行います
	 * @param strChange 変換対象文字列
	 * @return String 変換後文字列
	 */
	public static String setHttpChar(String strChange) {
		String strRes = "";
		try {
			strRes = new String(strChange.getBytes(BEFORE_CHARSET),AFTER_CHARSET);
		}
		catch(Exception e) {
			DebugLog.write( THIS_CLASS, e, DebugLog.HIGHT );
			return strRes;
		}
		return strRes.trim();
	}


}
